<!--
  -  Copyright 2020 Huawei Technologies Co., Ltd.
  -
  -  Licensed under the Apache License, Version 2.0 (the "License");
  -  you may not use this file except in compliance with the License.
  -  You may obtain a copy of the License at
  -
  -      http://www.apache.org/licenses/LICENSE-2.0
  -
  -  Unless required by applicable law or agreed to in writing, software
  -  distributed under the License is distributed on an "AS IS" BASIS,
  -  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -  See the License for the specific language governing permissions and
  -  limitations under the License.
  -->

<template>
  <div>
    <div class="pageTitle">
      <el-row>
        <div class="el-row-button-input">
          <label>
            {{ $t('nav.requestlist') }}
          </label>
          <el-button
            id="batchRejectsBtn"
            style="float:right;margin-left:15px"
            type="primary"
            @click="rejectRequest()"
            :disabled="selectedIds.length === 0"
          >
            <em class="el-icon-document-copy" />
            {{ $t('nav.batchRejects') }}
          </el-button>
          <el-button
            id="batchApproveBtn"
            style="float:right;margin-left:15px"
            type="primary"
            @click="approveApplication()"
            :disabled="selectedWaitingIds.length === 0"
          >
            <em class="el-icon-document-copy" />
            {{ $t('nav.batchApprove') }}
          </el-button>
        </div>
      </el-row>
    </div>
    <div class="userList">
      <el-row v-if="isResources">
        <el-col
          :span="8"
          style="margin-bottom: 80px"
        >
          <DoNut
            :chart-id="'reschartrequested'"
            name="Requested Resource"
            :graph-data="resReqGraphData"
            :label-pos="100"
            :graph-color="['#327ace', '#3fa981', '#e94349']"
            :legend-name="['Waiting', 'Approved', 'Rejected']"
          />
        </el-col>
        <el-col :span="8">
          <DoNut
            :chart-id="'reschartavailable'"
            name="Available Resource"
            :graph-data="resGraphData"
            :graph-color="['#327ace', '#3fa981']"
            :label-pos="100"
            :legend-name="[$t('Available'), 'Assigned']"
          />
        </el-col>
      </el-row>
      <el-row v-else>
        <el-col :span="8">
          <PiChart
            :chart-id="'envapprovedchart'"
            name="Approved Environment"
            :graph-data="piChartGraphData"
            :label-pos="100"
            :legend-name="['VA/AR', 'IoV', 'PowerGrid', 'Enterprise']"
          />
        </el-col>
        <el-col :span="8">
          <DoNut
            :chart-id="'envchartrequested'"
            name="Requested Environment"
            :graph-data="envReqGraphData"
            :label-pos="100"
            :graph-color="['#eeae5a', '#3fa981', '#e94349']"
            :legend-name="['Waiting', 'Approved', 'Rejected']"
          />
        </el-col>
        <el-col :span="8">
          <DoNut
            :chart-id="'envchartavailable'"
            name="Available Environment"
            :graph-data="envGraphData"
            :label-pos="100"
            :graph-color="['#327ace', '#3fa981']"
            :legend-name="[$t('Available'), 'Assigned']"
          />
        </el-col>
      </el-row>
      <el-tabs
        type="border-card"
        @tab-click="changeTabs"
        v-model="selectedTab"
      >
        <el-tab-pane
          :label="$t('nav.envapplication')"
          name="envapplication"
        >
          <SearchResource
            :lab-item="true"
            :status-item="true"
            @getSearchData="getEnvReqDataList"
          />
          <div class="tableDiv">
            <el-row>
              <el-col
                :span="24"
                class="table"
              >
                <el-table
                  v-loading="dataLoading"
                  :data="currPageEnvTableData"
                  border
                  @selection-change="handleSelectionChange"
                >
                  <el-table-column
                    type="selection"
                    width="55"
                  />
                  <el-table-column
                    prop="envName"
                    :label="$t('env.name')"
                  />
                  <el-table-column
                    prop="lab"
                    :label="$t('env.lab')"
                  />
                  <el-table-column
                    :label="$t('env.status')"
                    width="150"
                  >
                    <template slot-scope="scope">
                      <span
                        :style="getStatusColor(scope.row.status)"
                      >
                        {{ $t(scope.row.status) }}
                      </span>
                    </template>
                  </el-table-column>
                  <el-table-column
                    prop="type"
                    :label="$t('env.type')"
                  />
                  <el-table-column
                    prop="testOnSite"
                    width="100"
                    :label="$t('env.testOnSite')"
                  />
                  <el-table-column
                    prop="testCard"
                    width="100"
                    :label="$t('env.testCard')"
                  />
                  <el-table-column
                    prop="requestedBy"
                    width="140"
                    :label="$t('env.requestedBy')"
                  />
                  <el-table-column
                    :label="$t('common.operation')"
                    width="210"
                  >
                    <template slot-scope="scope">
                      <el-button
                        id="rejectBtn"
                        @click="rejectRequest(scope.row)"
                        type="text"
                        size="small"
                        :style="[scope.row.status === 'Rejected' ? {'color': ''} : {'color': '#409EFF'}]"
                        :disabled="scope.row.status === 'Rejected'"
                      >
                        {{ $t('nav.rejects') }}
                      </el-button>
                      <el-button
                        id="dltUsrBtn"
                        @click="approveApplication(scope.row)"
                        type="text"
                        size="small"
                        :style="[scope.row.status === 'Rejected' || scope.row.status === 'Approved' ? {'color': ''} : {'color': '#409EFF'}]"
                        :disabled="scope.row.status === 'Rejected' || scope.row.status === 'Approved'"
                      >
                        {{ $t('nav.approveapplication') }}
                      </el-button>
                    </template>
                  </el-table-column>
                </el-table>
              </el-col>
            </el-row>
            <div class="pageBar">
              <Pagination
                :table-data="paginationEnvReqData"
                @getCurrentPageData="getCurrentEnvPageData"
              />
            </div>
          </div>
        </el-tab-pane>
        <el-tab-pane
          :label="$t('nav.resapplication')"
          name="resapplication"
          disabled
        >
          <SearchResource
            :lab-item="true"
            :status-item="true"
            :applicant-item="true"
            @getSearchData="getResReqDataList"
          />
          <div class="tableDiv">
            <el-row>
              <el-col
                :span="24"
                class="table"
              >
                <el-table
                  v-loading="dataLoading"
                  :data="currPageResTableData"
                  border
                  @selection-change="handleSelectionChange"
                >
                  <el-table-column
                    type="selection"
                    width="55"
                  />
                  <el-table-column
                    prop="ipAddress"
                    :label="$t('env.ipAddress')"
                  />
                  <el-table-column
                    prop="lab"
                    :label="$t('env.lab')"
                  />
                  <el-table-column
                    :label="$t('env.status')"
                  >
                    <template slot-scope="scope">
                      <span
                        :style="getStatusColor(scope.row.status)"
                      >
                        {{ $t(scope.row.status) }}
                      </span>
                    </template>
                  </el-table-column>
                  <el-table-column
                    prop="specifications"
                    :label="$t('env.specifications')"
                  />
                  <el-table-column
                    prop="specialResources"
                    :label="$t('env.specialResources')"
                  />
                  <el-table-column
                    prop="requestedBy"
                    :label="$t('env.requestedBy')"
                  />
                  <el-table-column
                    prop="remark"
                    :label="$t('env.approvalRemarks')"
                  /> -->
                  <el-table-column
                    :label="$t('common.operation')"
                    width="210"
                  >
                    <template slot-scope="scope">
                      <el-button
                        id="editUsrBtn"
                        @click="rejectRequest(scope.row)"
                        type="text"
                        size="small"
                        :style="[scope.row.status === 'Rejected' ? {'color': ''} : {'color': '#409EFF'}]"
                        :disabled="scope.row.status === 'Rejected'"
                      >
                        {{ $t('nav.rejects') }}
                      </el-button>
                      <el-button
                        id="dltUsrBtn"
                        @click="approveApplication(scope.row)"
                        type="text"
                        size="small"
                        :style="[scope.row.status === 'Rejected' || scope.row.status === 'Approved' ? {'color': ''} : {'color': '#409EFF'}]"
                        :disabled="scope.row.status === 'Rejected' || scope.row.status === 'Approved'"
                      >
                        {{ $t('nav.approveapplication') }}
                      </el-button>
                    </template>
                  </el-table-column>
                </el-table>
              </el-col>
            </el-row>
            <div class="pageBar">
              <Pagination
                :table-data="paginationResReqData"
                @getCurrentPageData="getCurrentResPageData"
              />
            </div>
          </div>
        </el-tab-pane>
      </el-tabs>
      <el-dialog
        :title="$t('env.remark')"
        :visible.sync="dialogVisible"
        v-loading="loading"
      >
        <el-form
          label-width="180px"
        >
          <div style="margin-top: 15px;">
            <el-form-item
              :label="$t('env.remark')"
            >
              <el-input
                type="textarea"
                :rows="5"
                v-model="approvalRemarks"
                :placeholder="$t('env.remarkDetails')"
              />
            </el-form-item>
          </div>
          <div
            style="text-align:right"
          >
            <el-button
              id="cancelBtn"
              @click="cancel()"
            >
              {{ $t('common.cancel') }}
            </el-button>
            <el-button
              id="confirmBtn"
              type="primary"
              @click="confirm()"
              :loading="loading"
            >
              {{ $t('common.confirm') }}
            </el-button>
          </div>
        </el-form>
      </el-dialog>
    </div>
  </div>
</template>

<script>
import SearchResource from '../components/SearchResource.vue'
import Pagination from '../components/Pagination.vue'
import axios from 'axios'
import { BASE_URL } from '../tools/constant.js'
import PiChart from './PiChart.vue'
import DoNut from './DoNut.vue'
export default {
  name: 'ResourceList',
  components: {
    SearchResource,
    PiChart,
    DoNut,
    Pagination
  },
  data () {
    return {
      dataLoading: true,
      envDataList: [],
      resDataList: [],
      dialogVisible: false,
      loading: false,
      dialogLoading: false,
      currentRowData: {},
      isResources: false,
      selectedIds: [],
      selectedWaitingIds: [],
      resReqGraphData: [],
      envReqGraphData: [],
      resGraphData: [],
      envGraphData: [],
      piChartGraphData: [],
      approvalRemarks: '',
      isApprove: false,
      selectedTab: 'envapplication',
      paginationResReqData: [],
      paginationEnvReqData: [],
      currPageEnvTableData: [],
      currPageResTableData: []
    }
  },
  mounted () {
    this.getEnvReqDataList()
    this.getResReqDataList()
  },
  computed: {
  },
  methods: {
    getCurrentEnvPageData (data) {
      this.currPageEnvTableData = data
    },
    getCurrentResPageData (data) {
      this.currPageResTableData = data
    },
    getStatusColor (status) {
      let statusColor = {}
      switch (status) {
        case 'Available':
          statusColor = { 'color': '#327ace' }
          break
        case 'Waiting':
          statusColor = { 'color': '#eeae5a' }
          break
        case 'Rejected':
          statusColor = { 'color': '#e82003' }
          break
        case 'Assigned':
        case 'Approved':
          statusColor = { 'color': '#3fa981' }
          break
      }
      return statusColor
    },
    changeTabs (evt) {
      if (evt.name === 'resapplication') {
        this.isResources = true
        this.selectedTab = 'resapplication'
        this.getResReqDataList()
      } else {
        this.selectedTab = 'envapplication'
        this.getEnvReqDataList()
        this.isResources = false
      }
    },
    handleSelectionChange (val) {
      this.selectedIds = []
      this.selectedWaitingIds = []
      let isApprovedSel = false
      val.map(item => {
        this.selectedIds.push(item.id)
        if (item.status === 'Approved') {
          isApprovedSel = true
          this.selectedIds.push(item.id)
        } else if (item.status === 'Waiting') {
          this.selectedWaitingIds.push(item.id)
          this.selectedIds.push(item.id)
        }
      })
      if (isApprovedSel) {
        this.selectedWaitingIds = []
      }
    },
    async getEnvReqDataList (data) {
      if (!data) {
        data = {
          name: '',
          lab: 'ALL',
          status: 'ALL'
        }
      }
      this.getEnvDataList(data)
      let userId = sessionStorage.getItem('userId')
      let url = `${BASE_URL}/getEnvRequest?userId=${userId}&name=${data.name}&lab=${data.lab}&status=${data.status}`
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.paginationEnvReqData = res.data.envRequestData
        this.envReqGraphData = [
          { value: res.data.requestedCount, name: 'Waiting' },
          { value: res.data.approvedCount, name: 'Approved' },
          { value: res.data.rejectedCount, name: 'Rejected' }
        ]
        this.piChartGraphData = [
          { value: res.data.typeCount ? res.data.typeCount.vrarCount : 0, name: 'VA/AR' },
          { value: res.data.typeCount ? res.data.typeCount.iovCount : 0, name: 'IoV' },
          { value: res.data.typeCount ? res.data.typeCount.powergridCount : 0, name: 'PowerGrid' },
          { value: res.data.typeCount ? res.data.typeCount.industrialCount : 0, name: 'Enterprise' }
        ]
        this.dataLoading = false
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.dataLoading = false
        }
      })
    },
    async getResReqDataList (data) {
      if (!data) {
        data = {
          ipAddress: '',
          status: 'ALL',
          lab: 'ALL',
          requestedBy: ''
        }
      }
      this.getResDataList(data)
      let userId = sessionStorage.getItem('userId')
      let url = `${BASE_URL}/getResourceRequest?userId=${userId}&ipAddress=${data.ipAddress}&lab=${data.lab}&status=${data.status}&requestedBy=${data.requestedBy}`
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.paginationResReqData = res.data.resourceRequestData
        this.resReqGraphData = [
          { value: res.data.requestedCount, name: 'Waiting' },
          { value: res.data.approvedCount, name: 'Approved' },
          { value: res.data.rejectedCount, name: 'Rejected' }
        ]
        this.dataLoading = false
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.dataLoading = false
        }
      })
    },
    async getEnvDataList (data) {
      let userId = sessionStorage.getItem('userId')
      let url = `${BASE_URL}/getEnv?userId=${userId}&name=${data.name}&lab=${data.lab}&status=${data.status}`
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.envGraphData = [
          { value: res.data.availableCount, name: 'Available' },
          { value: res.data.assignedCount, name: 'Assigned' }
        ]
        this.dataLoading = false
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.dataLoading = false
        }
      })
    },
    async getResDataList (data) {
      let userId = sessionStorage.getItem('userId')
      let url = `${BASE_URL}/getResource?userId=${userId}&ipAddress=${data.ipAddress}&lab=${data.lab}&status=${data.status}&requestedBy=${data.requestedBy}`
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.resGraphData = [
          { value: res.data.availableCount, name: 'Available' },
          { value: res.data.assignedCount, name: 'Assigned' }
        ]
        this.dataLoading = false
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.dataLoading = false
        }
      })
    },
    cancel () {
      this.currentRowData = {}
      this.dialogVisible = false
      this.isApprove = false
    },
    async confirm () {
      if (this.isApprove) {
        this.confirmApproveApplication()
      } else {
        this.confirmRejectRequest()
      }
    },
    approveApplication (row) {
      this.dialogVisible = true
      this.isApprove = true
      this.currentRowData = row
    },
    confirmApproveApplication () {
      let data = []
      let url = BASE_URL + '/envRequestBatchApprove'
      if (this.currentRowData && Object.keys(this.currentRowData).length !== 0) {
        data.push(this.currentRowData.id)
      } else {
        data = this.selectedWaitingIds
      }
      if (this.isResources) {
        url = BASE_URL + '/resourceRequestBatchApprove'
      }
      axios({
        method: 'PUT',
        url: url,
        data: { 'ids': data, 'approvalRemarks': this.approvalRemarks },
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.$parent.successMessage(this.$t('confirm.approveConfim'))
        this.getEnvReqDataList()
        this.getResReqDataList()
        this.cancel()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.dataLoading = false
          this.cancel()
        }
      })
    },
    rejectRequest (row) {
      this.dialogVisible = true
      this.isApprove = false
      this.currentRowData = row
    },
    confirmRejectRequest () {
      let data = []
      let url = BASE_URL + '/envRequestBatchReject'
      if (this.currentRowData && Object.keys(this.currentRowData).length !== 0) {
        data.push(this.currentRowData.id)
      } else {
        data = this.selectedIds
      }
      if (this.isResources) {
        url = BASE_URL + '/resourceRequestBatchReject'
      }
      axios({
        method: 'DELETE',
        url: url,
        data: { 'ids': data, 'approvalRemarks': this.approvalRemarks },
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.getEnvReqDataList()
        this.getResReqDataList()
        this.cancel()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.dataLoading = false
          this.cancel()
        }
      })
    }
  }
}
</script>

<style lang='less' scoped>
.pageTitle {
  margin: 5% 2% 1% 2%;
  font-weight: bold;
}
.userList {
    margin: 0 2%;
    height: 100%;
    background: #fff;
  .tableDiv {
    width: 100%;
  }
  .el-row-button-input {
    margin-top: 10px;
  }
  .table {
    margin-top: 15px;
  }
  .el-row-table {
    margin-top: 10px;
  }
  .shortdesc{
    overflow: hidden;
    text-overflow: ellipsis;
    display:-webkit-box;
    -webkit-box-orient:vertical;
    -webkit-line-clamp:2;
  }
}
</style>
